﻿@page "/users"

<PageTitle>Users*</PageTitle>

@using Bakery.Data


<h1>Current Users</h1>

<p>To add new User, press button below.</p>
<div class="container mt-3">
    <h3>Modal Example</h3>
    <p>Click on the button to open the modal.</p>

    <button type="button" class="btn btn-primary" @onclick="()=>ChangeModalDisplay()">
        Open modal
    </button>
</div>

<!-- The Modal -->
<div class="modal" id="myModal" tabindex="-1" role="dialog" style="display:@showmodal">
    <div class="modal-dialog" role="document">
        <div class="modal-content">

            <!-- Modal Header -->
            <div class="modal-header">
                <h4 class="modal-title">Modal Heading</h4>
                <button type="button" class="btn-close" data-bs-dismiss="modal" @onclick="()=>ChangeModalDisplay()"></button>
            </div>

            <!-- Modal body -->
            <div class="modal-body">
                <EditForm Model="@additionalUser" OnValidSubmit="@AddUser">
                    <DataAnnotationsValidator />
                    <ValidationSummary />

                    <div class="row">

                        <div style="margin-left: 20px;">
                            Firstname
                        </div>

                        <div style="width:50%; margin-left: 20px;">
                            <InputText id="name1" @bind-Value="additionalUser.Firstname" />
                        </div>

                    </div>
                    <br>

                    <div class="row">
                        <div style="margin-left: 20px;">
                            Lastname
                        </div>
                        <div style="width:50%; margin-left: 20px;">
                            <InputText id="name2" @bind-Value="additionalUser.Lastname" />
                        </div>

                        @*<InputText id="name" @bind-Value="additionalUser.Age.ToString()" />*@
                    </div>
                    <br>

                    <div class="row">

                        <div style="margin-left: 20px;">
                            Tel
                        </div>

                        <div style="width:50%; margin-left: 20px;">
                            <InputText id="name1" @bind-Value="additionalUser.Firstname" />
                        </div>

                    </div>
                    <div class="row">

                        <div style="margin-left: 20px;">
                            E-Mail
                        </div>

                        <div style="width:50%; margin-left: 20px;">
                            <InputText id="name1" @bind-Value="additionalUser.Firstname" />
                        </div>

                    </div>




















                    <div class="row">

                        <button class="btn-info" type="submit"></button>
                    </div>

                </EditForm>
            </div>

            <!-- Modal footer -->
            <div class="modal-footer">
                <button type="button" class="btn btn-danger" data-bs-dismiss="modal" @onclick="()=>ChangeModalDisplay()"> Close</button>
            </div>

        </div>
    </div>
</div>


@if (users == null)
{
    <p><em>Loading...</em></p>
}
else
{
    <table class="table">
        <thead>
            <tr>
                <th>Firstname</th>
                <th>Lastname</th>
                <th>Age</th>
                <th>Remove User</th>
            </tr>
        </thead>
        <tbody>
            @foreach (User u in users)
            {
                <tr>
                    <td>@u.Firstname</td>
                    <td>@u.Lastname</td>
                    <td>@u.Age</td>
                    <td>
                        <button type="button" class="btn btn-danger" data-bs-dismiss="modal" @onclick="()=>RemoveUser(u.Id)"> Remove</button>

                    </td>
                </tr>
            }
            <tr>
                <td></td>
                <td>Total</td>
                <td>@average</td>
            </tr>
        </tbody>
    </table>
}

@code {
    private List<User> users = new List<User>();

    private User additionalUser = new User();

    private string showmodal = "none";

    private double average;

    protected override async Task OnInitializedAsync()
    {
        User user1 = new User();
        user1.Firstname = "Max";
        user1.Lastname = "Folt";
        user1.Age = 20;
        user1.Id = Guid.NewGuid();

        User user2 = new User();
        user2.Firstname = "Maria";
        user2.Lastname = "Rev";
        user2.Age = 26;
        user2.Id = Guid.NewGuid();

        users.Add(user1);
        users.Add(user2);

        average = users.Sum(a => a.Age) / users.Count;
    }


    private void ChangeModalDisplay()
    {
        if (showmodal.Equals("none"))
        {
            showmodal = "block";
            return;
        }

        if (showmodal.Equals("block"))
        {
            showmodal = "none";
            return;
        }
        StateHasChanged();
    }

    private void AddUser()
    {
        if (additionalUser != null)
        {
            users.Add(additionalUser);
            additionalUser.Id = Guid.NewGuid();
            additionalUser = new User();
            average = users.Sum(a => a.Age) / users.Count;

        }
        StateHasChanged();
    }

    private void RemoveUser(Guid guid )
    {
        users.RemoveAll(b => b.Id == guid);
        average = users.Sum(a => a.Age) / users.Count;  
        StateHasChanged();
    }

}
